## hueplusplus 1.2.0%2Bds

=== test/CMakeLists.txt ===
if(NOT hueplusplus_NO_EXTERNAL_LIBRARIES)
    find_package(GTest)
    find_package(GMock)
endif()

if(NOT GTest_FOUND OR NOT GMock_FOUND)
    # Download and unpack googletest at configure time
    configure_file(CMakeLists.txt.in googletest-download/CMakeLists.txt)
    execute_process(COMMAND ${CMAKE_COMMAND} -G ${CMAKE_GENERATOR} .
        RESULT_VARIABLE result
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/googletest-download"
    )
    if(result)
        message(FATAL_ERROR "CMake step for googletest failed: ${result}")
    endif()
    execute_process(COMMAND "${CMAKE_COMMAND}" --build .
        RESULT_VARIABLE result
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/googletest-download"
    )
    if(result)
        message(FATAL_ERROR "Build step for googletest failed: ${result}")
    endif()

    # Prevent overriding the parent project's compiler/linker
    # settings on Windows
    set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)

    # Add googletest directly to our build. This defines
    # the gtest and gtest_main targets.
    add_subdirectory(${CMAKE_CURRENT_BINARY_DIR}/googletest-src EXCLUDE_FROM_ALL
                     ${CMAKE_CURRENT_BINARY_DIR}/googletest-build EXCLUDE_FROM_ALL
    )
    target_compile_features(gmock PUBLIC cxx_std_14)
    target_compile_features(gtest PUBLIC cxx_std_14)
endif()


# define all test sources
set(TEST_SOURCES
    test_Action.cpp
    test_APICache.cpp
    test_BaseDevice.cpp
    test_BaseHttpHandler.cpp
    test_Bridge.cpp
    test_BridgeConfig.cpp
    test_SensorImpls.cpp
    test_ColorUnits.cpp
    test_ExtendedColorHueStrategy.cpp
    test_ExtendedColorTemperatureStrategy.cpp
    test_Group.cpp
    test_HueCommandAPI.cpp
    test_Light.cpp
    test_LightFactory.cpp
    test_Main.cpp
    test_NewDeviceList.cpp
    test_UPnP.cpp
    test_ResourceList.cpp
    test_Rule.cpp
    test_Scene.cpp
    test_Schedule.cpp
    test_Sensor.cpp
    test_SensorList.cpp
    test_SimpleBrightnessStrategy.cpp
    test_SimpleColorHueStrategy.cpp
    test_SimpleColorTemperatureStrategy.cpp
    test_StateTransaction.cpp
    test_TimePattern.cpp)

set(HuePlusPlus_INCLUDE_DIR "${PROJECT_SOURCE_DIR}/include")

# test executable
add_executable(test_HuePlusPlus ${TEST_SOURCES})
#if(DO_CLANG_TIDY)
#	set_target_properties(test_HuePlusPlus PROPERTIES CXX_CLANG_TIDY ${DO_CLANG_TIDY})
#endif()
target_compile_features(test_HuePlusPlus PUBLIC cxx_std_14)
set_property(TARGET test_HuePlusPlus PROPERTY CXX_EXTENSIONS OFF)

target_link_libraries(test_HuePlusPlus PUBLIC hueplusplusstatic)
target_link_libraries(test_HuePlusPlus PUBLIC gtest gmock)
target_include_directories(test_HuePlusPlus PUBLIC ${GTest_INCLUDE_DIRS})
# add custom target to make it simple to run the tests
add_custom_target("unittest"
    # Run the executable
    COMMAND test_HuePlusPlus
    # Depends on test_HuePlusPlus
    DEPENDS test_HuePlusPlus
)

# Check for coverage test prerequisites
find_program( GCOV_PATH gcov )
find_program( LCOV_PATH lcov )

mark_as_advanced(GCOV_PATH)
mark_as_advanced(LCOV_PATH)

if(LCOV_PATH AND GCOV_PATH)
    # GCov
    include(CodeCoverage.cmake)
    add_executable(testcov_HuePlusPlus ${TEST_SOURCES} ${hueplusplus_SOURCES})
    target_include_directories(testcov_HuePlusPlus PUBLIC "${PROJECT_SOURCE_DIR}/include")
    target_compile_features(testcov_HuePlusPlus PUBLIC cxx_std_14)
    set_property(TARGET testcov_HuePlusPlus PROPERTY CXX_EXTENSIONS OFF)

    target_link_libraries(testcov_HuePlusPlus PRIVATE mbedtls)
    target_link_libraries(testcov_HuePlusPlus PUBLIC nlohmann_json::nlohmann_json gtest gmock)
    target_include_directories(testcov_HuePlusPlus PUBLIC ${GTest_INCLUDE_DIRS})
    # this will be already done by APPEND_COVERAGE_COMPILER_FLAGS()
    #set_target_properties(
    #        testcov_HuePlusPlus PROPERTIES
    #        COMPILE_FLAGS "-O0 -g -fprofile-arcs -ftest-coverage"
    #)
    # Normally this would be -lgcov, but on mac only -Lgcov works
    #set_target_properties(
    #        testcov_HuePlusPlus PROPERTIES
    #        LINK_FLAGS "-O0 -g -Lgcov -fprofile-arcs -ftest-coverage"
    #)
    # exclude some special files we do not want to profile
    set(COVERAGE_EXCLUDES
        '/usr/*'           # unix
        '*/hueplusplus/build/*'
        '*/json*'
        '*/test/*'
        '*/v1/*'           # iOS
    )
    APPEND_COVERAGE_COMPILER_FLAGS()
    SETUP_TARGET_FOR_COVERAGE(
            NAME "coveragetest"
            EXECUTABLE testcov_HuePlusPlus
            DEPENDENCIES testcov_HuePlusPlus
    )
endif()

## hueplusplus 1.2.0+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2...3.28)

# Add cmake dir to module path, so Find*.cmake can be found
set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

project(hueplusplus VERSION 1.2.0 LANGUAGES CXX)

# check whether hueplusplus is compiled directly or included as a subdirectory
if(NOT DEFINED hueplusplus_master_project)
	if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)
		set(hueplusplus_master_project ON)
	else()
		set(hueplusplus_master_project OFF)
	endif()
endif()

# options to set
option(hueplusplus_TESTS "Build tests" OFF)
option(hueplusplus_EXAMPLES "Build examples" OFF)
option(hueplusplus_NO_EXTERNAL_LIBRARIES "Do not try to use external libraries" OFF)

# Try to find installed packages
if(NOT hueplusplus_NO_EXTERNAL_LIBRARIES)
    # Suppress warnings if libraries are not found, they will be built from submodules
	find_package(MbedTLS QUIET)
	find_package(nlohmann_json QUIET)
endif()

set(NEED_SUBMODULES NOT (${MbedTLS_FOUND} AND ${nlohmann_json_FOUND}))

option(CLANG_TIDY_FIX "Perform fixes for Clang-Tidy" OFF)
find_program(CLANG_TIDY_EXE NAMES "clang-tidy" DOC "Path to clang-tidy executable")
if(CLANG_TIDY_EXE)
	if(CLANG_TIDY_FIX)
		set(DO_CLANG_TIDY "${CLANG_TIDY_EXE}" "-fix")
	else()
		set(DO_CLANG_TIDY "${CLANG_TIDY_EXE}")
	endif()
endif()

# update submodules
find_package(Git QUIET)
if(GIT_FOUND AND EXISTS "${PROJECT_SOURCE_DIR}/.git")
	option(GIT_SUBMODULE "Check submodules during build" ON)
	if(GIT_SUBMODULE AND NEED_SUBMODULES)
		message(STATUS "Submodule update")
		execute_process(COMMAND ${GIT_EXECUTABLE} submodule update --init --recursive WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
			RESULT_VARIABLE GIT_SUBMOD_RESULT)
		if(NOT GIT_SUBMOD_RESULT EQUAL "0")
			message(FATAL_ERROR "git submodule update --init failed with ${GIT_SUBMOD_RESULT}, please checkout submodules")
		endif()
	endif()
endif()

# Set default build type if none was specified
set(default_build_type "Release")
if(hueplusplus_master_project AND (NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES))
	message(STATUS "Setting build type to '${default_build_type}' as none was specified")
	set(CMAKE_BUILD_TYPE "${default_build_type}" CACHE STRING "Choose the type of build." FORCE)
	# Set possible values for cmake-gui
	set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
		"Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()


# get the correct installation directory for add_library() to work
if(WIN32 AND NOT CYGWIN)
  set(DEF_INSTALL_CMAKE_DIR cmake)
else()
  set(DEF_INSTALL_CMAKE_DIR lib/cmake/hueplusplus)
endif()
set(INSTALL_CMAKE_DIR ${DEF_INSTALL_CMAKE_DIR} CACHE PATH "Installation directory for CMake files")

# target for uninstall
if(NOT TARGET uninstall)
    configure_file(
        "${PROJECT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
        "${PROJECT_BINARY_DIR}/cmake_uninstall.cmake"
        IMMEDIATE @ONLY)

    add_custom_target(uninstall
        COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
endif()

# if we are on a apple machine this is needed
if (1 AND APPLE)
	set(CMAKE_MACOSX_RPATH 1)
endif()

if(NOT MbedTLS_FOUND)
	# Build mbedtls if not installed
	message(STATUS "MbedTLS was not found, the submodule is used.")
	set(USE_STATIC_MBEDTLS_LIBRARY ON)
	set(USE_SHARED_MBEDTLS_LIBRARY OFF)
	add_subdirectory("lib/mbedtls" EXCLUDE_FROM_ALL)

	# Compile the mbedtls library as a static with position independent code,
	# because we need it for both a shared and static library
	set_property(TARGET mbedtls PROPERTY POSITION_INDEPENDENT_CODE ON)
	set_property(TARGET mbedcrypto PROPERTY POSITION_INDEPENDENT_CODE ON)
	set_property(TARGET mbedx509 PROPERTY POSITION_INDEPENDENT_CODE ON)

	if(CMAKE_VERSION VERSION_LESS 3.18)
		# Aliases for compatibility with find_package, newer cmake versions add these already
		add_library(MbedTLS::mbedtls ALIAS mbedtls)
		add_library(MbedTLS::mbedcrypto ALIAS mbedcrypto)
		add_library(MbedTLS::mbedx509 ALIAS mbedx509)
	endif()
endif()

if(NOT nlohmann_json_FOUND)
	# Use embedded json
	message(STATUS "nlohmann_json was not found, the submodule is used.")
	# disable tests for json
	set(JSON_BuildTests OFF CACHE INTERNAL "")
	add_subdirectory("lib/json" EXCLUDE_FROM_ALL)
endif()

add_subdirectory(src)

# if the user decided to use tests add the subdirectory
if(hueplusplus_TESTS)
    add_subdirectory("test")
endif()

if(hueplusplus_EXAMPLES)
	add_subdirectory("examples")
endif()

=== examples/CMakeLists.txt ===
add_executable(bridge_setup BridgeSetup.cpp)
set_property(TARGET bridge_setup PROPERTY CXX_STANDARD 14)
set_property(TARGET bridge_setup PROPERTY CXX_EXTENSIONS OFF)
target_link_libraries(bridge_setup hueplusplusstatic)

add_executable(lights_off LightsOff.cpp)
set_property(TARGET lights_off PROPERTY CXX_STANDARD 14)
set_property(TARGET lights_off PROPERTY CXX_EXTENSIONS OFF)
target_link_libraries(lights_off hueplusplusstatic)


add_executable(username_config UsernameConfig.cpp)
set_property(TARGET lights_off PROPERTY CXX_STANDARD 14)
set_property(TARGET lights_off PROPERTY CXX_EXTENSIONS OFF)
target_link_libraries(username_config hueplusplusstatic)

add_custom_target(hueplusplus_examples)
add_dependencies(hueplusplus_examples bridge_setup lights_off username_config)

# Snippets for documentation, not included with the examples target
add_executable(hueplusplus_snippets Snippets.cpp)
set_property(TARGET hueplusplus_snippets PROPERTY CXX_STANDARD 14)
set_property(TARGET hueplusplus_snippets PROPERTY CXX_EXTENSIONS OFF)
target_link_libraries(hueplusplus_snippets hueplusplusstatic)

=== src/CMakeLists.txt ===
set(hueplusplus_SOURCES
    Action.cpp
    APICache.cpp
    BaseDevice.cpp
    BaseHttpHandler.cpp
    Bridge.cpp
    BridgeConfig.cpp
    CLIPSensors.cpp
    ColorUnits.cpp
    EntertainmentMode.cpp
    ExtendedColorHueStrategy.cpp
    ExtendedColorTemperatureStrategy.cpp
    Group.cpp
    HueCommandAPI.cpp
    HueDeviceTypes.cpp
    HueException.cpp
    Light.cpp
    ModelPictures.cpp
    NewDeviceList.cpp
    Rule.cpp
    Scene.cpp
    Schedule.cpp
    Sensor.cpp
    SimpleBrightnessStrategy.cpp
    SimpleColorHueStrategy.cpp
    SimpleColorTemperatureStrategy.cpp
    StateTransaction.cpp
    TimePattern.cpp
    UPnP.cpp
    Utils.cpp 
    ZLLSensors.cpp)

# on windows we want to compile the WinHttpHandler
if(WIN32)
    set(hueplusplus_SOURCES
        ${hueplusplus_SOURCES}
        WinHttpHandler.cpp
    )
endif()
# whereas on linux we want the LinHttpHandler
if(UNIX)
    set(hueplusplus_SOURCES
        ${hueplusplus_SOURCES}
        LinHttpHandler.cpp
    )
endif()
if(ESP_PLATFORM)
    set(hueplusplus_SOURCES
        ${hueplusplus_SOURCES}
        LinHttpHandler.cpp
    )
endif()

# append current source dir before files
foreach(src ${hueplusplus_SOURCES})
    list(APPEND _srcList "${CMAKE_CURRENT_SOURCE_DIR}/${src}")
endforeach()
set(hueplusplus_SOURCES ${_srcList} PARENT_SCOPE)

# For install dir variables
include(GNUInstallDirs)

# hueplusplus shared library
add_library(hueplusplusshared SHARED ${hueplusplus_SOURCES})
target_link_libraries(hueplusplusshared PRIVATE MbedTLS::mbedtls)
target_link_libraries(hueplusplusshared PUBLIC nlohmann_json::nlohmann_json)
target_compile_features(hueplusplusshared PUBLIC cxx_std_14)
target_include_directories(hueplusplusshared PUBLIC $<BUILD_INTERFACE:${hueplusplus_SOURCE_DIR}/include> $<INSTALL_INTERFACE:include>)


# hueplusplus static library
add_library(hueplusplusstatic STATIC ${hueplusplus_SOURCES})
target_link_libraries(hueplusplusstatic PRIVATE MbedTLS::mbedtls)
target_link_libraries(hueplusplusstatic PUBLIC nlohmann_json::nlohmann_json)
target_compile_features(hueplusplusstatic PUBLIC cxx_std_14)
if(NOT WIN32)
    # On windows, a shared library will also generate a .lib import library, making different names necessary.
    # On other platforms the file endings are different, so the names can be the same.
    set_target_properties(hueplusplusshared PROPERTIES OUTPUT_NAME hueplusplus SOVERSION 1)
    set_target_properties(hueplusplusstatic PROPERTIES OUTPUT_NAME hueplusplus)
endif()

install(TARGETS hueplusplusshared DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(TARGETS hueplusplusstatic DESTINATION ${CMAKE_INSTALL_LIBDIR})
target_include_directories(hueplusplusstatic PUBLIC $<BUILD_INTERFACE:${hueplusplus_SOURCE_DIR}/include> $<INSTALL_INTERFACE:include>)
install(DIRECTORY "${PROJECT_SOURCE_DIR}/include/" DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

# Export the package for use from the build-tree
# (this registers the build-tree with a global CMake-registry)
export(PACKAGE hueplusplus)
# Create the hueplusplus-config.cmake
configure_file ("${PROJECT_SOURCE_DIR}/cmake/hueplusplus-config.cmake.in" "${hueplusplus_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/hueplusplus-config.cmake" @ONLY)
# Install hueplusplus-config.cmake
install(FILES "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/hueplusplus-config.cmake" DESTINATION "${INSTALL_CMAKE_DIR}" COMPONENT dev)

=== debian/changelog ===
hueplusplus (1.2.0+ds-2) unstable; urgency=medium

  * Add d/gbp.conf for a better gbp-clone
  * Fix FTBFS on openrgb due to nlohmann-json3 version
  * Add doc/html to clean to allow repeat build
  * d/control: Add and generate Static-Built-Using

 -- Ahmad Khalifa <ahmad@khalifa.ws>  Sat, 31 May 2025 16:26:59 +0100

hueplusplus (1.2.0+ds-1) unstable; urgency=medium

  * New upstream version 1.2.0
  * d/copyright: remove excludes after upstream movement
  * d/patches: remove all patches after upstream fixes
  * d/rules: quieter build output
  * d/not-installed: fix path of ignore static lib
  * d/control: bump standards version to latest 4.7.2

 -- Ahmad Khalifa <ahmad@khalifa.ws>  Tue, 15 Apr 2025 17:14:58 +0100

hueplusplus (1.1.0+ds-2) unstable; urgency=medium

  * Source-only upload for testing migration

 -- Matthias Geiger <werdahias@debian.org>  Tue, 15 Apr 2025 10:47:33 +0200

hueplusplus (1.1.0+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #1091681)
  * d/copyright: Add missing copyright holders
  * d/copyright: split additional copyright holders

 -- Ahmad Khalifa <ahmad@khalifa.ws>  Mon, 24 Feb 2025 18:16:36 +0000

=== debian/control ===
Source: hueplusplus
Section: libs
Priority: optional
Maintainer: Ahmad Khalifa <ahmad@khalifa.ws>
Rules-Requires-Root: no
Build-Depends: cmake,
               debhelper-compat (= 13),
               libmbedtls-dev,
               nlohmann-json3-dev
Build-Depends-Indep: dh-sequence-doxygen, doxygen, graphviz
Standards-Version: 4.7.2
Homepage: https://github.com/enwi/hueplusplus
Vcs-Browser: https://salsa.debian.org/debian/hueplusplus
Vcs-Git: https://salsa.debian.org/debian/hueplusplus.git

Package: libhueplusplus1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Static-Built-Using: ${StaticBuiltUsing}
Description: simple C++ library to control Philips Hue lights
 A simple and easy to use library for Philips Hue Lights
 Features:
  - find bridges with SSDP or set an ip manually
  - all common light functions (brightness, color, temperature)
  - extended alert() functions, which alert in a specific color
    (good for notifications)
  - supports sensors, rules, groups, scenes and schedules
  - streaming with entertainment mode
  - documented with doxygen
  - tested with google test, google mock and gcov/lcov

Package: libhueplusplus1-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libhueplusplus1 (= ${binary:Version}), ${misc:Depends}
Description: simple C++ library to control Philips Hue lights (headers)
 A simple and easy to use library for Philips Hue Lights.
 .
 This package provides the header files.

Package: libhueplusplus1-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: simple C++ library to control Philips Hue lights (docs)
 A simple and easy to use library for Philips Hue Lights.
 .
 This package provides the documentation files.

=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/default.mk
# compile nlohmann-json3 without versioned namespaces: #1106432
export DEB_CXXFLAGS_MAINT_APPEND = -DNLOHMANN_JSON_NAMESPACE_NO_VERSION
NL3_VERSION = $(shell dpkg-query '--showformat=$${Version}' --show 'nlohmann-json3-dev')

%:
	dh $@

execute_after_dh_auto_build-indep:
	# build docs and replace version
	sed 's/^PROJECT_NUMBER.*/PROJECT_NUMBER = $(DEB_VERSION)/' Doxyfile | \
		doxygen -

override_dh_gencontrol:
	test ! -z "$(NL3_VERSION)"
	dh_gencontrol -- -VStaticBuiltUsing="nlohmann-json3-dev (= $(NL3_VERSION))"

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%, \
    repacksuffix=+ds, dversionmangle=s/\+ds//" \
    https://github.com/enwi/hueplusplus/tags \
    (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@

# previously used to pull in commits from branch external-deps
#opts="mode=git, pgpmode=none, pretty=1.1.0+git%cd" \
#  https://github.com/enwi/hueplusplus.git heads/external-deps
